import java.util.Scanner;

/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {

	public static int updateHash(int H, int aIn, int aOut, int c, int cToK, int mod) {
		return (H * c + aIn + (mod - cToK) * aOut) % mod;
	}

	public static int compHash(int[] A, int from, int len, int c, int cToK, int mod) {
		int H = 0, i;
		for (i = from; i < from + len; i++)
			H = updateHash(H, A[i], 0, c, cToK, mod);
		return H;
	}

	public static void main(String[] args) {

		// Read from the standard input with java.util.Scanner
		Scanner scanner = new Scanner(System.in);

		// Read the number of paragraphs and page width
		int case_no, cases = scanner.nextInt();

		for (case_no = 1; case_no <= cases; case_no++) {

			// Sizes of array A and array B
			int n = scanner.nextInt();
			int k = scanner.nextInt();
			int[] A = new int[n];
			int[] B = new int[k];
			int i;
			// Read elements of A and elements of B
			for (i = 0; i < n; i++) {
				A[i] = scanner.nextInt();
			}
			for (i = 0; i < k; i++) {
				B[i] = scanner.nextInt();
			}

			int c = 1021;    	// c < 2^10,
			int mod = 32768; 	// mod = 2^15
			int cToK = 1;     	// cToK = (c ^ k) % mod
			for (i = 0; i < k; i ++) {
				cToK = (cToK * c) % mod; // need to apply the modulo on every iteration!
			}

			// Compute the hash for B[0 .. k-1], that is entire B
			int AHash = 0; 		// AHash < mod
			// Compute the hash for A[0 .. k-1]
			int BHash = 0; 		// BHash < mod
			for (i = 0; i < k; i ++) {
				AHash = updateHash(AHash, A[i], 0, c, cToK, mod);
				BHash = updateHash(BHash, B[i], 0, c, cToK, mod);
			}

			// Start with hash of A[i .. i+k-1], compare to hash of B, then update to hash of A[i+1 .. i+k]
			for (i = 0; i <= n - k; i++) {
				/*
				int H2 = compHash(A, i, k, c, cToK, mod);
				if (H2 != AHash) {
					System.err.println("Hash error at " + i + ": " + AHash + " vs " + H2);
				}
				*/
				if (AHash == BHash) {
					// The hashes match, but we still should compare the arrays
					int j;
					boolean matches = true;
					for (j = 0; (j < k) && matches; j++) {
						if (A[i + j] != B[j])
							matches = false;
					}
					// Output the starting index in A if they match, or warn that we got a false alarm
					if (matches) {
						System.out.print(i + " ");
					} else {
						System.err.println("False match at " + i);
					}
				}

				// Do not update the hash in the last iteration (this would access A[n])
				if (i < n - k)
					AHash = updateHash(AHash, A[i + k], A[i], c, cToK, mod);
			}

			System.out.println("DONE");
		}

		scanner.close();
	}
}
